package org.springframework.data.relational.core.sql;

import org.springframework.data.relational.core.sql.render.FunctionVisitor;

import java.util.Arrays;
import java.util.List;

/**
 * 可以渲染函数的条件
 *
 * @author wangyu
 */
public class FunctionCondition extends ConstantCondition implements Condition {

    private final SimpleFunction function;

    private FunctionCondition(SimpleFunction function) {
        super("");
        this.function = function;
    }

    public static Condition of(String functionName, List<Expression> args) {
        return new FunctionCondition(SimpleFunction.create(functionName, args));
    }

    public static Condition of(String functionName, Expression... args) {
        return of(functionName, Arrays.asList(args));
    }

    @Override
    public String toString() {
        FunctionVisitor visitor = new FunctionVisitor();
        return function.toString();
    }
}
